
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;                                                                        ;
;          EXAMPLE 1 - INTELLIGENT DISPLAY DRIVER                        ;
;          THIS ROUTINE WRITES "8748" TO THE NSM 1416 4 DIGIT DISPLAY    ;
;                                                                        ;
;          LABEL A CODE WRITES THE LETTER "X" TO ALL 4 DIGITS            ;
;                                                                        ;
;          LABEL B CLEARS THE CURSOR WITHIN THE NSM 1416                 ;
;                                                                        ;
;          LABEL C WRITES "8748" INTO DIGITS 0-3                         ;
;                                                                        ;
;          LABEL D HALTS THE PROGRAM BY LOOPING ON ITSELF                ;
;                                                                        ;
;          SUBROUTINE WRITEX PERFORMS THE WRITE FUNCTION                 ;
;                                                                        ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

           .ORG 000H
A          MOV  A,#00000111B     ;WRITE LETTER X TO ALL 4 DIGITS
           CALL WRITEX           ;WRITE TO DIGIT 3
           MOV  A,#00000110B
           CALL WRITEX           ;WRITE TO DIGIT 2
           MOV  A,#00000101B
           CALL WRITEX           ;WRITE TO DIGIT 1
           MOV  A,#00000100B
           CALL WRITEX           ;WRITE TO DIGIT 0

B          ANL  P2,#00000000B    ;CLEAR THE CURSOR
           MOV  A,#0
           MOVX @R0,A

C          MOV  A,#000000111B    ;WRITE LETTER 8 TO DIGIT 3
           OUTL P2,A
           MOV  A,#'8'
           MOVX @R0,A

           MOV  A,#000000110B    ;WRITE LETTER 7 TO DIGIT 2
           OUTL P2,A
           MOV  A,#'7'
           MOVX @R0,A

           MOV  A,#000000101B    ;WRITE LETTER 4 TO DIGIT 1
           OUTL P2,A
           MOV  A,#'4'
           MOVX @R0,A

           MOV  A,#000000100B    ;WRITE LETTER 8 TO DIGIT 0
           OUTL P2,A
           MOV  A,#'8'
           MOVX @R0,A

D          JMP  $                ;LOOP HERE FOREVER

WRITEX     OUTL P2,A             ;WRITE LETTER X SUBROUTINE
           MOV  A,#'X'
           MOVX @R0,A
           RET
           .END
